Cantera 2.6.0

Public Member Functions | Protected Attributes | List of all members
TsangRate Class Referencefinal
Chemical Kinetics » Falloff Parameterizations

The 1- or 2-parameter Tsang falloff parameterization. More...

`#include <Falloff.h>`

Inheritance diagram for TsangRate:
[legend]
Collaboration diagram for TsangRate:
[legend]

## Public Member Functions
| TsangRate ()
| Constructor. More...
| TsangRate (const AnyMap &node, const UnitStack &rate_units={})
| TsangRate (const ArrheniusRate &low, const ArrheniusRate &high, const vector_fp &c)
unique_ptr< MultiRateBase > | newMultiRate () const
| Create a rate evaluator for reactions of a particular derived type. More...
virtual void | setFalloffCoeffs (const vector_fp &c)
| Set coefficients used by parameterization. More...
virtual void | getFalloffCoeffs (vector_fp &c) const
| Retrieve coefficients of the falloff parameterization. More...
virtual void | updateTemp (double T, double *work) const
| Update the temperature parameters in the representation. More...
virtual double | F (double pr, const double *work) const
| The falloff function. More...
virtual size_t | workSize () const
| The size of the work array required. More...
virtual const std::string | type () const
| String identifying reaction rate specialization. More...
virtual size_t | nParameters () const
| Returns the number of parameters used by this parameterization. More...
virtual void | setParameters (const AnyMap &node, const UnitStack &rate_units)
| Set parameters. More...
virtual void | getParameters (double *params) const
| Sets params to contain, in order,. More...
virtual void | getParameters (AnyMap &node) const
| Get parameters. More...
Public Member Functions inherited from FalloffRate
| FalloffRate (const AnyMap &node, const UnitStack &rate_units={})
void | init (const vector_fp &c)
| Initialize. More...
virtual void | setFalloffCoeffs (const vector_fp &c)
| Set coefficients of the falloff parameterization. More...
virtual void | getFalloffCoeffs (vector_fp &c) const
| Retrieve coefficients of the falloff parameterization. More...
virtual void | updateTemp (double T, double *work) const
| Update the temperature-dependent portions of the falloff function, if any, and store them in the 'work' array. More...
virtual double | F (double pr, const double *work) const
| The falloff function. More...
double | evalF (double T, double conc3b)
| Evaluate falloff function at current conditions. More...
virtual size_t | workSize () const
| The size of the work array required. More...
virtual const std::string | type () const
| String identifying reaction rate specialization. More...
virtual size_t | nParameters () const
| Returns the number of parameters used by this parameterization. More...
virtual void | setParameters (const AnyMap &node, const UnitStack &rate_units)
| Set parameters. More...
virtual void | getParameters (double *params) const
| Get the values of the parameters for this object. More...
virtual void | getParameters (AnyMap &node) const
| Get parameters. More...
virtual double | evalFromStruct (const FalloffData &shared_data)
| Evaluate reaction rate. More...
void | check (const std::string &equation, const AnyMap &node)
| Check basic syntax and settings of reaction rate expression. More...
virtual void | validate (const std::string &equation, const Kinetics &kin)
| Validate the reaction rate expression. More...
bool | allowNegativePreExponentialFactor () const
| Get flag indicating whether negative A values are permitted. More...
void | setAllowNegativePreExponentialFactor (bool value)
| Set flag indicating whether negative A values are permitted. More...
bool | chemicallyActivated () const
| Get flag indicating whether reaction is chemically activated. More...
void | setChemicallyActivated (bool activated)
| Set flag indicating whether reaction is chemically activated. More...
ArrheniusRate & | lowRate ()
| Get reaction rate in the low-pressure limit. More...
void | setLowRate (const ArrheniusRate &low)
| Set reaction rate in the low-pressure limit. More...
ArrheniusRate & | highRate ()
| Get reaction rate in the high-pressure limit. More...
void | setHighRate (const ArrheniusRate &high)
| Set reaction rate in the high-pressure limit. More...
Public Member Functions inherited from ReactionRate
| ReactionRate (const ReactionRate &other)
ReactionRate & | operator= (const ReactionRate &other)
virtual unique_ptr< MultiRateBase > | newMultiRate () const
| Create a rate evaluator for reactions of a particular derived type. More...
virtual const std::string | type () const =0
| String identifying reaction rate specialization. More...
virtual void | setParameters (const AnyMap &node, const UnitStack &units)
| Set parameters. More...
AnyMap | parameters () const
| Return the parameters such that an identical Reaction could be reconstructed using the newReaction() function. More...
virtual void | check (const std::string &equation, const AnyMap &node)
| Check basic syntax and settings of reaction rate expression. More...
virtual void | validate (const std::string &equation, const Kinetics &kin)
| Validate the reaction rate expression. More...
virtual void | validate (const std::string &equation)
| Validate the reaction rate expression (legacy call) More...
size_t | rateIndex () const
| Reaction rate index within kinetics evaluator. More...
void | setRateIndex (size_t idx)
| Set reaction rate index within kinetics evaluator. More...
virtual void | setContext (const Reaction &rxn, const Kinetics &kin)
| Set context of reaction rate evaluation. More...
double | eval (double T)
| Evaluate reaction rate based on temperature. More...
double | eval (double T, double extra)
| Evaluate reaction rate based on temperature and an extra parameter. More...
double | eval (double T, const std::vector< double > &extra)
| Evaluate reaction rate based on temperature and an extra vector parameter. More...

## Protected Attributes
double | m_a
| parameter a in the Tsang F_cent formulation. Dimensionless More...
double | m_b
| parameter b in the Tsang F_cent formulation. [K^-1] More...
Protected Attributes inherited from FalloffRate
ArrheniusRate | m_lowRate
| The reaction rate in the low-pressure limit. More...
ArrheniusRate | m_highRate
| The reaction rate in the high-pressure limit. More...
bool | m_chemicallyActivated
| Flag labeling reaction as chemically activated. More...
bool | m_negativeA_ok
| Flag indicating whether negative A values are permitted. More...
double | m_rc_low
| Evaluated reaction rate in the low-pressure limit. More...
double | m_rc_high
| Evaluated reaction rate in the high-pressure limit. More...
vector_fp | m_work
| Work vector. More...
Protected Attributes inherited from ReactionRate
AnyMap | m_input
| Input data used for specific models. More...
size_t | m_rate_index
| Index of reaction rate within kinetics evaluator. More...

## Additional Inherited Members
virtual void | getParameters (AnyMap &node) const
| Get parameters. More...

## Detailed Description

The 1- or 2-parameter Tsang falloff parameterization.

The Tsang falloff model is adapted from that of Troe. It provides a constant or linear in temperature value for \( F_{cent} \):

\[ F_{cent} = A + B*T \]

The value of \( F_{cent} \) is then applied to Troe's model for the determination of the value of \( F \):

\[ F = F_{cent}^{1/(1 + f_1^2)} \]

where

\[ f_1 = (\log_{10} P_r + C) / \left(N - 0.14 (\log_{10} P_r + C)\right) \]

\[ C = -0.4 - 0.67 \log_{10} F_{cent} \]

\[ N = 0.75 - 1.27 \log_{10} F_{cent} \]

References: Example of reaction database developed by Tsang utilizing this format: https://doi.org/10.1063/1.555890 Example of Chemkin implementation of Tsang format (supplemental materials): https://doi.org/10.1016/j.combustflame.2011.02.010

Definition at line 546 of file Falloff.h.

## Constructor & Destructor Documentation

## ◆ TsangRate() [1/3]

TsangRate | ( |  | ) |
| inline

Constructor.

Definition at line 550 of file Falloff.h.

References FalloffRate::m_work.

## ◆ TsangRate() [2/3]

TsangRate | ( | const AnyMap & | node,
|  | const UnitStack & | rate_units = `{}`
| ) |  |
| inline

Definition at line 554 of file Falloff.h.

## ◆ TsangRate() [3/3]

TsangRate | ( | const ArrheniusRate & | low,
|  | const ArrheniusRate & | high,
|  | const vector_fp & | c
| ) |  |
| inline

Definition at line 560 of file Falloff.h.

## Member Function Documentation

## ◆ newMultiRate()

unique_ptr< MultiRateBase > newMultiRate | ( |  | ) | const
| inline virtual

Create a rate evaluator for reactions of a particular derived type.

Derived classes usually implement this as:

unique_ptr<MultiRateBase> newMultiRate() const override {
return unique_ptr<MultiRateBase>(new MultiRate<RateType, DataType>);
Cantera::MultiRate
A class template handling ReactionRate specializations.
Definition: MultiRate.h:21
Cantera::TsangRate::newMultiRate
unique_ptr< MultiRateBase > newMultiRate() const
Create a rate evaluator for reactions of a particular derived type.
Definition: Falloff.h:568

where `RateType` is the derived class name and `DataType` is the corresponding container for parameters needed to evaluate reactions of that type.

Reimplemented from ReactionRate.

Definition at line 568 of file Falloff.h.

## ◆ setFalloffCoeffs()

void setFalloffCoeffs | ( | const vector_fp & | c | ) |
| virtual

Set coefficients used by parameterization.

Parameters

  c | Vector of one or two doubles: The doubles are the parameters, a and (optionally) b of the Tsang F_cent parameterization

Reimplemented from FalloffRate.

Definition at line 444 of file Falloff.cpp.

## ◆ getFalloffCoeffs()

void getFalloffCoeffs | ( | vector_fp & | c | ) | const
| virtual

Retrieve coefficients of the falloff parameterization.

Parameters

  c | Vector of coefficients of the parameterization. The number and meaning of these coefficients is subclass-dependent.

Reimplemented from FalloffRate.

Definition at line 461 of file Falloff.cpp.

References Cantera::SmallNumber.

## ◆ updateTemp()

void updateTemp | ( | double | T,
|  | double * | work
| ) |  | const
| virtual

Update the temperature parameters in the representation.

Parameters

  T | Temperature (Kelvin)
  work | Vector of working space, length 1, representing the temperature-dependent part of the parameterization.

Reimplemented from FalloffRate.

Definition at line 470 of file Falloff.cpp.

## ◆ F()

double F | ( | double | pr,
|  | const double * | work
| ) |  | const
| virtual

The falloff function.

This is defined so that the rate coefficient is

\[ k = F(Pr)\frac{Pr}{1 + Pr}. \]

Here \( Pr \) is the reduced pressure, defined by

\[ Pr = \frac{k_0 [M]}{k_\infty}. \]

Parameters

  pr | reduced pressure (dimensionless).
  work | array of size workSize() containing cached temperature-dependent intermediate results from a prior call to updateTemp.

Returns
  the value of the falloff function \( F \) defined above

Reimplemented from FalloffRate.

Definition at line 476 of file Falloff.cpp.

## ◆ workSize()

virtual size_t workSize | ( |  | ) | const
| inline virtual

The size of the work array required.

Todo:
  deprecate; only used by legacy framework

Reimplemented from FalloffRate.

Definition at line 591 of file Falloff.h.

## ◆ type()

virtual const std::string type | ( |  | ) | const
| inline virtual

String identifying reaction rate specialization.

Reimplemented from FalloffRate.

Definition at line 595 of file Falloff.h.

## ◆ nParameters()

virtual size_t nParameters | ( |  | ) | const
| inline virtual

Returns the number of parameters used by this parameterization.

The values of these parameters can be obtained from getParameters().

Reimplemented from FalloffRate.

Definition at line 599 of file Falloff.h.

## ◆ setParameters()

void setParameters | ( | const AnyMap & | node,
|  | const UnitStack & | units
| ) |  |
| virtual

Set parameters.

Parameters

  node | AnyMap object containing reaction rate specification
  units | unit definitions specific to rate information

Reimplemented from FalloffRate.

Definition at line 486 of file Falloff.cpp.

References AnyMap::empty().

## ◆ getParameters() [1/2]

void getParameters | ( | double * | params | ) | const
| virtual

Sets params to contain, in order,.

\[ (A, B) \]

Todo:
  deprecate; superseded by getFalloffCoeffs

Reimplemented from FalloffRate.

Definition at line 504 of file Falloff.cpp.

## ◆ getParameters() [2/2]

void getParameters | ( | AnyMap & | node | ) | const
| virtual

Get parameters.

Parameters

  node | AnyMap containing rate information Store the parameters of a ReactionRate needed to reconstruct an identical object. Does not include user-defined fields available in the m_input map.

Reimplemented from FalloffRate.

Definition at line 509 of file Falloff.cpp.

References AnyMap::setFlowStyle().

## Member Data Documentation

## ◆ m_a

double m_a
| protected

parameter a in the Tsang F_cent formulation. Dimensionless

Definition at line 615 of file Falloff.h.

## ◆ m_b

double m_b
| protected

parameter b in the Tsang F_cent formulation. [K^-1]

Definition at line 618 of file Falloff.h.

The documentation for this class was generated from the following files:

- Falloff.h
- Falloff.cpp